declare module 'typedi/Container' {
	export interface Instance {
	    type: Function;
	    instance: Object;
	}
	export interface CustomParamHandler {
	    type: Function;
	    index: number;
	    getValue: () => any;
	}
	export class Container {
	    static instances: Instance[];
	    static customParamHandlers: CustomParamHandler[];
	    static registerCustomParamHandler(paramHandler: CustomParamHandler): void;
	    static get<T>(type: Function, params?: any[]): T;
	    private static findInstanceOfType(type);
	    private static findCustomParamHandler(type, index);
	    private static mapParams(type, params);
	}

}
declare module 'typedi/Inject' {
	export function Inject(type?: Function): (target: any, key: string) => void;

}
declare module 'typedi/Require' {
	export function Require(name: string): (target: Function, key: string, index: number) => void;

}
declare module 'typedi/Resolve' {
	export function Resolve(): (target: Function) => void;

}
